﻿<cfcomponent>
	<cffunction name="getSiteAPI" access="public" output="false" returntype="query">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="#session.current_site_id#">
            <cfquery datasource="#application.DB#" name="GetSiteAPI">
                SELECT #arguments.fields# FROM ice_site_api  WHERE 0=0
<cfif isdefined("form.ice_status_id") AND form.ice_status_id IS NOT 0>AND ice_status_id=#form.ice_status_id#</cfif>
<cfif isdefined("form.ice_site_api") AND form.ice_site_api IS NOT ''>AND (ice_site_api LIKE '%#form.ice_site_api#%' OR description LIKE '%#form.ice_site_api#%')</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT 0>AND id IN (#arguments.id#)</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.status_id") AND arguments.status_id IS NOT  0>AND ice_status_id = #arguments.status_id#</cfif>
ORDER BY ice_site_api ASC
            </cfquery>
		<cfreturn GetSiteAPI>
	</cffunction>


	<cffunction name="getSessionKey" access="public" output="false" returntype="string">
		<cfargument name="api_key" type="string" required="no" default="">
		<cfargument name="uname" type="string" required="no" default="">
		<cfargument name="pword" type="string" required="no" default="">

            <cfquery datasource="#application.DB#" name="CheckAPI">
                SELECT id,ice_site_id FROM ice_site_api 
		WHERE api_key='#arguments.api_key#'
            </cfquery>

<cfif CheckAPI.Recordcount IS 1>
            <cfquery datasource="#application.DB#" name="CheckUser" maxrows="1">
                SELECT id FROM ice_site_member WHERE email='#arguments.uname#' AND pword='#arguments.pword#' AND ice_site_id=(SELECT ice_site_id FROM ice_site_api WHERE api_key='#arguments.api_key#') AND ice_status_id=1
            </cfquery>
		<CFIF CheckUser.Recordcount IS 1>
            		<cfquery datasource="#application.DB#" name="CheckAPIUser" maxrows="1">
                	SELECT id FROM ice_site_api_user WHERE ice_site_member_id=#CHeckUser.id# AND ice_site_id=#CheckAPI.ice_site_id# AND ice_site_api_id=#checkapi.id# AND ice_status_id=1
            		</cfquery>			
				<cfif CheckAPIUser.Recordcount IS 1>		
				<cfinvoke component="site" method="getSiteFolder" site_id="#CheckAPI.ice_site_id#" returnvariable="folder">

		<cfset session.api_session_key=createUUID()>
		<cfset session.api_id=CheckAPI.id>
		<cfset session.api_site_id=CheckAPI.ice_site_id>
		<cfset session.api_site_folder=folder.folder>
		<cfset session.api_user_id=#CheckUser.id#>
		<cfset form.session_key=session.api_session_key>
		<cfset form.id=#CheckUser.id#>
		<cfupdate tablename="ice_site_api_user" datasource="#application.db#" formfields="id,session_key">
		<cfset key=form.session_key><cfreturn key>
				<cfelse>
				<cfset key='Access Denied'><cfreturn key>
				</cfif>
		<CFELSE>
		<cfset key='Invalid Login'><cfreturn key>
		</CFIF>

<cfelse>
<cfset key='Wrong API Key'><cfreturn key>
</cfif>
	</cffunction>


	<cffunction name="countSiteAPI" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountSiteAPI">
                SELECT #arguments.fields# FROM ice_site_api 
WHERE 0=0
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT 0>AND ice_status_id=#arguments.ice_status_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
            </cfquery>
<cfset countlanguage=CountSiteAPI.Recordcount>
		<cfreturn countlanguage>
	</cffunction>


	<cffunction name="addSiteAPI" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="user_id" type="string" required="no" default="0">
<cfset form.ice_site_id=#session.current_site_id#>
<cfset form.ice_user_id=#session.user_id#>
<cfset form.created=now()>
<cfset form.api_key=createUUID()>
<cftry>
<cfinsert tablename="ice_site_api" datasource="#application.db#" formfields="#arguments.fields#,ice_user_id,ice_site_id,api_key,created">

<cfcatch type="any"><cfset addlanguage=0><cfreturn addlanguage></cfcatch>
</cftry>	
<cfset addlanguage=1>
		<cfreturn addlanguage>
	</cffunction>

	<cffunction name="updateSiteAPI" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">

<cftry>

<cfupdate tablename="ice_site_api" datasource="#application.db#" formfields="id,#arguments.fields#">
<cfcatch type="any"><cfset updatelanguage=0><cfreturn updatelanguage></cfcatch>
</cftry>	

<cfset updatelanguage=1>
		<cfreturn updatelanguage>

	</cffunction>

	<cffunction name="deleteSiteAPI" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="id" type="string" required="no" default="0">
<CFIF Isdefined("url.confirm") AND url.confirm IS 'yes'>
<cftry>

<cfquery name="DeleteSiteAPIComponent" datasource="#application.db#">
DELETE FROM ice_site_api_component WHERE ice_site_api_id=#arguments.id#
</cfquery>
<cfquery name="DeleteSiteAPI" datasource="#application.db#">
DELETE FROM ice_site_api WHERE id=#arguments.id#
</cfquery>
<cfcatch type="any"><cfset deletelanguage=0><cfreturn deletelanguage></cfcatch>
</cftry>	
<cfset deletelanguage=1>
<cfelse>
<cfset deletelanguage=0><cfreturn deletelanguage>
</cfif>
		<cfreturn deletelanguage>
	</cffunction>
</cfcomponent>